from MetaConf import *
import tempfile
import commands
import sys, os

def run(element, opts, parms):
    logger.debug("starting 'command' function")
    logger.debug("shell='%s', show='%s', error='%s'" %
                 (element.get("shell", "/bin/sh"),
                 element.get("show", "false"),
                 element.get("error", "show")))
    shell = element.get("shell", "/bin/sh")
    lines = element.text.strip().splitlines()
    name = lines[0]
    if len(name) > 30 or len(lines) > 1:
        name = name[:30] + " ..."
    logger.debug("creating temporary file")
    fd, filename = tempfile.mkstemp()
    logger.debug("created temporary file '%s'" % filename)
    data = element.text
    try:
        f = os.fdopen(fd, "w")
        if parms:
            logger.debug("writting command with parameters"+filename)
            try:
                f.write(data % parms)
            except (KeyError, ValueError), e:
                if isinstance(e, KeyError):
                    raise Error, "command '%s' requires undeclared " \
                                 "parameter %s" % (name, str(e))
                else:
                    raise Error, "command '%s' has invalid parameters" % name
        else:
            logger.debug("writting command without parameters"+filename)
            f.write(data)
        f.flush()
        if not opts.dryrun:
            logger.info("executing command (%s): %s" % (shell, name))
            status, output = commands.getstatusoutput("%s %s" %
                                                      (shell, filename))
        else:
            logger.info("would execute command (%s): %s" % (shell, name))
            status, output = 0, ""
    finally:
        logger.debug("removing temporary file")
        os.close(fd)
        os.unlink(filename)
    if element.get("show") in ("true", "1"):
        if output:
            print output
    elif status != 0 and element.get("error") != "ignore":
        if output:
            raise Error, "command '%s' failed:\n%s" % (name, output)
        else:
            raise Error, "command '%s' failed" % name
    logger.debug("finishing 'command' function")

# vim:sw=4:ts=4:et
