from MetaConf import *

def inherit(stack, opts, name, element):
    logger.debug("found '%s' in '%s' at 0x%x" %
                 (name, element.tag, id(element)))
    logger.info("inheriting from '%s'" % name)
    execute(stack, element, opts)

def run(stack, element, opts):
    logger.debug("starting 'inherit' function")
    names = element.text.split()
    logger.debug("trying to inherit from: "+" ".join(names))
    for name in names[:]:
        for scope in stack[1:]:
            for child in scope.element:
                if child.get("name") == name:
                    inherit(stack, opts, name, child)
                    names.remove(name)
                    break
            else:
                continue
            # Internal break will break outside for
            break
        else:
            logger.debug("trying to find '%s' in nested metaconfs" % name)
            for scope in stack[1:]:
                for child in scope.element:
                    if child.tag.lower() == "metaconf":
                        logger.debug("found nested metaconf at 0x%x" %
                                     id(child))
                        for subchild in child:
                            if subchild.get("name") == name:
                                inherit(stack, opts, name, subchild)
                                names.remove(name)
                                break
    if names:
        logger.warning("can't inherit from: "+" ".join(names))
    logger.debug("finishing 'inherit' function")

